
-- Network Client Prepopulated data
insert into host_type (type, name) values (0,'WAUTH');
insert into host_type (type, name) values (1,'Radius');
insert into host_type (type, name) values (2,'LDAP');
insert into host_type (type, name) values (3,'TACACS+');
insert into host_type (type, name) values (4,'GoogleSSO');
insert into host_subtype (subtype,name) values (1,'Authentication');
insert into host_subtype (subtype,name) values (2,'Accounting');

-- Enable wAuth by default
insert into host (name,ip,port,enabled,Config,type,subtype,debug_level,multihome,restrict_nc) values ('localhost','0.0.0.0',8388,1,'',0,1,0,0,1);

-- Add default, hidden internal objects for logging consistency

insert into full_domain (id_domain,code,name,ddname,minpin,valid,maxbads,maxoffs,tacacs,maxattempts,publickey,privatekey) values (0,'000000000000','internal','internal',0,0,0,0,0,0,'','');
insert into full_network_client (id_nc,ip,name,enforced,domain) values(0,'0.0.0.0','internal',0,0);

-- Default System Preferences

insert into parms1to1 (key,value,description,class) values ('wAuthPoolSize','5','Num+of+DB+pool+conns+for+wAuth','wAuth               ');
insert into parms1to1 (key,value,description,class) values ('radMinPack','20','Minimum RADIUS receive packets','AuthServer          ');
insert into parms1to1 (key,value,description,class) values ('radMaxPack','500','Maximum RADIUS receive packets','AuthServer          ');
insert into parms1to1 (key,value,description,class) values ('wAuthKeyStore','%2fopt%2fWiKID%2fprivate%2fwAuthServerKeys','WiKIDAuth+Protocol+SSL+keys','wAuth               ');
insert into parms1to1 (key,value,description,class) values ('wAuthCAStore','%2fopt%2fWiKID%2fprivate%2fCACertStore','CA+Certificate+Store+for+wAuth','wAuth               ');
insert into parms1to1 (key,value,description,class) values ('wAuthKeyStoreType','PKCS12','The+Keystore+Type+for+wAuth','wAuth               ');
insert into parms1to1 (key,value,description,class,hide) values ('wAuthCAStorePW','changeit','CA+Cert+Store+Password','wAuth               ',TRUE);
insert into parms1to1 (key,value,description,class) values ('RegCodeTTL','1440','Minutes+a+reg+code+is+good','timecop             ');
insert into parms1to1 (key,value,description,class) values ('WikidCodeSDEBUG','false','Enable+debugging+in+WikidCodeS','WikidCodeS          ');
insert into parms1to1 (key,value,description,class) values ('InitDevice2SDEBUG','false','Set+debug+mode+for+InitDevice2','InitDevice2S        ');
insert into parms1to1 (key,value,description,class) values ('wAuthDEBUG','false','Turns+on%2foff+debug+mode','wAuth               ');
insert into parms1to1 (key,value,description,class,hide) values ('demowClientPass','passphrase','Password+for+the+demo+app','wAuth               ',TRUE);
insert into parms1to1 (key,value,description,class) values ('radKeyStore','%2fopt%2fWiKID%2fprivate%2flocalhost.p12','Cert+Store+for+the+RADIUS+Mod','wAuth               ');
insert into parms1to1 (key,value,description,class,hide) values ('localhost.p12PW','passphrase','Password+for+the+RADIUS+Module','wAuth               ',TRUE);
insert into parms1to1 (key,value,description,class) values ('UnRegDeviceTTL','1440','Unregistered Device TTL','InitDevice2S        ');
insert into parms1to1 (key,value,description,class) values ('IncompDeviceTTL','5','Incomplete Device TTL','InitDevice2S        ');
insert into parms1to1 (key,value,description,class) values ('LDAP_wauth_host','127.0.0.1','LDAP WiKID host','LDAP');
insert into parms1to1 (key,value,description,class) values ('LDAP_wauth_port','8388','LDAP WiKID host prt','LDAP');
insert into parms1to1 (key,value,description,class) values ('LDAP_wauth_kfile','/opt/WiKID/private/localhost.p12','LDAP client cert','LDAP');
insert into parms1to1 (key,value,description,class,hide) values ('LDAP_wauth_pass','passphrase','LDAP client cert pw','LDAP',TRUE);
insert into parms1to1 (key,value,description,class) values ('LDAP_wauth_server','000000000000','LDAP Auth Domain','LDAP');

-- default WiKIDAdmin credentials for tomcat

insert into tomcat_users (username,password) values ('WiKIDAdmin','27465020c9ea11fc41fac2af1daeba5f');
insert into tomcat_roles (username,role) values ('WiKIDAdmin','WiKIDAdmin');
insert into tomcat_roles (username,role) values ('tomcat','WiKIDAdmin');
insert into tomcat_roles (username,role) values ('tomcat','tomcat');



-- the new types of crypto that can be associated with a domain.

-- optional addition (the classic ntru encryption, which is handled differently):
-- INSERT INTO cryptotype (id_cryptotype, keyalg, ciphertransformation) VALUES (0, 'NTRU', 'NTRU');
-- if this is added, id_cryptotype in full_devices (which references cryptotype.id_cryptotype)
-- could be made NOT NULL.  seems like a pain for upgrade/downgrades scripts though.

INSERT INTO cryptotype (id_cryptotype, keyalg, ciphertransformation) VALUES (1, 'RSA', 'RSA/ECB/PKCS1PADDING');

-- Elliptical curve needs some work - these may not be be the right params.
-- INSERT INTO cryptotype (id_cryptotype, keyalg, ciphertransformation) VALUES (2, 'ECIES', 'ECIES');

update db_version set version=19;