#!/bin/bash

. /etc/WiKID/setenv.sh

retval=-1

if [ -x /usr/bin/pg_lsclusters ]; then
	pgstatus=`/usr/bin/pg_lsclusters | grep 5432 | awk '{print $4}' 2>/dev/null`
	if [ "$pgstatus" = "down" ]; then	
		retval=1
	elif [ "$pgstatus" = "online" ]; then
		retval=0
	fi
else
	pgstatus=`$WIKID_HOME/sbin/service.sh postgresql status 2> /dev/null`
	status=`echo $pgstatus | grep stopped`
	check=$?
	# check == 1 means the pattern wasn't found, i.e. it's not stopped
	if [ "$check" = "1" ]; then	
		retval=0
	else
		retval=1
	fi
fi

# return values:
# 0 = running
# 1 = not running
echo $retval
exit $retval

