#!/bin/bash

. /etc/WiKID/setenv.sh

SUDO=$WIKID_HOME/sbin/sudo.sh

LOG=/opt/WiKID/log/install.log
TMPLOG=`mktemp -t wikid-installXXXXX` || exit 1
DIR=/opt/WiKID/conf/database

## let's see if we need to start postgres
pgstatus=`$WIKID_HOME/sbin/check_pg.sh`
if [ "1" = "$pgstatus" ]; then
	$WIKID_HOME/sbin/service.sh postgresql start > /dev/null 2>&1
fi

psql -h localhost -U postgres wikid -l > /dev/null 2>&1
wikid_db_check=$?

if [ "$wikid_db_check" != 0 ]; then
(
	echo "Initializing WiKID database ..."

	$SUDO postgres "psql -h localhost -d template1 -f $DIR/db-users.sql"
	$SUDO postgres "psql -h localhost -d template1 -f $DIR/wikid-schema.sql"
	$SUDO postgres "psql -h localhost -d wikid -f $DIR/db-data.sql"
	sleep 3
) >> $TMPLOG 2>&1
fi
grep -v "NOTICE:" $TMPLOG
cat $TMPLOG >> $LOG


## stop postgres if it was running when we started
if [ "1" = "$pgstatus" ]; then
	$WIKID_HOME/sbin/service.sh postgresql stop > /dev/null 2>&1
fi
