#!/bin/bash

# Exit if cert/key file got getting cert already exists
[ -f /opt/WiKID/var/update/update_cert.p12 ] && {
   [ /opt/WiKID/var/update/update_cert.p12 -nt /opt/WiKID/private/intCAKeys.p12 ] && exit 0
}

openssl pkcs12 -in /opt/WiKID/private/intCAKeys.p12 -passin "pass:$1" -out /opt/WiKID/var/update/update_cert.pem -passout "pass:$1" 2>/dev/null && {
   openssl rsa -modulus -in /opt/WiKID/var/update/update_cert.pem -passin "pass:$1" -noout 2>/dev/null | sed 's/^Modulus=//' | md5sum | awk '{print $1}' > /opt/WiKID/var/update/cert_modulus_md5sum
   openssl pkcs12 -export -out /opt/WiKID/var/update/update_cert.p12 -in /opt/WiKID/var/update/update_cert.pem -passin "pass:$1" -passout "pass:$1"
   ret=$?
   rm -f /opt/WiKID/var/update/update_cert.pem
   exit $ret
}
exit $?
