#!/bin/bash

arg=$1
BASEPATH=${arg:=/opt/WiKID}
# echo "setting up base path: $BASEPATH"

if [ ! -d "$BASEPATH" ]; then
	echo "Invalid BASEPATH!"
	exit 4
fi

useradd -d $BASEPATH -c "WiKID daemon" -M -r -s /bin/bash wikid
usermod -G sudo wikid 
if [ -z "$PS1" ]; then
	# shell is interactive, so let's ask for the password
	passwd wikid
else
	# shell is non-interactive, so set a default
	echo wikid:8ebccbc43a8929446f1e637b902a9bd5 | chpasswd -m -e
	chage -d 0 wikid
fi

chown -R wikid $BASEPATH

secfile="/etc/WiKID/security"
tmpfile=`mktemp` || /tmp/tmpfile.$$ # i know, i know ...
if [ -f "$secfile" ]; then
	grep -v WIKID_USER= $secfile > $tmpfile
	mv $tmpfile $secfile
fi
echo 'WIKID_USER="wikid"' >> $secfile
rm $tmpfile

