#!/usr/bin/perl -w
use strict;
use lib '/opt/WiKID/lib';
use WiKIDUpdate;
my %pkgs;

if ($ARGV[0] and ($ARGV[0] eq '--help')) {
   print STDERR "Usage: $0\n";
   print STDERR "Compares your WiKID Authentication Server software against\n";
   print STDERR "the official package list and shows all differences.\n";
   exit 1;
}

foreach (&WiKIDUpdate::get_lines_from_server("http://updates.wikidsystems.com/wikid/servlet/com.wikidsystems.updater.update?action=verify&release=$WiKIDUpdate::release&build=$WiKIDUpdate::build&quality=$WiKIDUpdate::quality&hostname=$WiKIDUpdate::hostname&ipaddr=$WiKIDUpdate::ipaddr&modulus=$WiKIDUpdate::modulus")) {
   chomp;
   if (/^(.+)-([^-]+-[^-]+)$/) {
      $pkgs{$1}{'ideal'} = $2;
   }
}

my %actual;
foreach (`rpm -qa`) {
   chomp;
   if (/^(.+)-([^-]+-[^-]+)$/) {
      unless ($1 eq 'gpg-pubkey') {
         $pkgs{$1}{'actual'} = $2;
      }
   }
}

my $changed = 0;
foreach my $pkg (keys %pkgs) {
   if ($pkgs{$pkg}{'actual'} and $pkgs{$pkg}{'ideal'}) {
      unless ($pkgs{$pkg}{'actual'} eq $pkgs{$pkg}{'ideal'}) {
         $changed++;
         print "Changed Locally $pkg-$pkgs{$pkg}{'ideal'} -> $pkg-$pkgs{$pkg}{'actual'}\n";
      }
   } elsif ($pkgs{$pkg}{'actual'}) {
      $changed++;
      print "Added Locally $pkg-$pkgs{$pkg}{'actual'}\n";
   } elsif ($pkgs{$pkg}{'ideal'}) {
      $changed++;
      print "Removed Locally $pkg-$pkgs{$pkg}{'ideal'}\n";
   }
}

exit $changed;
