#!/bin/bash

SYSTEM_CONF="/opt/WiKID/conf/system.conf"
WIKID_CONFIGURED=0
if [ -f $SYSTEM_CONF ]; then
	. $SYSTEM_CONF
fi

if [ "$WIKID_CONFIGURED" = "1" ]; then
	#echo "WiKID already configured."
	exit 0;
fi

/opt/WiKID/sbin/setup_wikid_user.sh /opt/WiKID

#check if JAVAHOME is set, else quit per 'proprietarysucks' via irc
[[ $JAVAHOME ]] && { echo JAVAHOME not set; exit 123; }

# rpmbuild doesn't always get these right:
chmod +x /opt/WiKID/sbin/*.pl /opt/WiKID/sbin/*.sh

for cmd in setup start stop demote promote recover synch upgrade; 
do
	ln -sf /opt/WiKID/sbin/wikid.pl /opt/WiKID/bin/wikid_$cmd
done
ln -sf /opt/WiKID/sbin/wikid.pl /opt/WiKID/sbin/setup

# make sure Postgres has been initialized, which is checked during startup
#/sbin/chkconfig postgresql on
#if [ ! -d /var/lib/pgsql/data/base ]; then
#	/sbin/service postgresql start
#	/sbin/service postgresql stop
#fi

mkdir -p /opt/WiKID/var/update

## clear requiretty flag so sudo will work during boot
perl -p -i'.wikid' -e 's,^(Defaults\s+requiretty),#$1,' /etc/sudoers

appliance=0
if [ "$1" = "-intrusive" ]; then
	appliance=1
elif [ -f /opt/WiKID/conf/mode.conf ]; then
	mode=`cat /opt/WiKID/conf/mode.conf`
	if [ "$mode" = "appliance" ]; then
		appliance=1
	fi
fi

#cp -af /opt/WiKID/webapps/{wikid,WiKIDAdmin}.war /opt/WiKID/tomcat/webapps

# copy, since the scripts (attempt to) delete themselves
#cp /opt/WiKID/conf/templates/wikid-firstboot.sh /etc/rc3.d/S99wikid-firstboot.sh
chmod +x /opt/WiKID/conf/templates/wikid-firstboot.sh
/opt/WiKID/conf/templates/wikid-firstboot.sh


# for some reason JAVA_HOME isn't getting set correctly in some cases.  Double checking it ...
if [ "$JAVA_HOME" == "" ]; then
    if [ -f /opt/java/jre/bin/java ]; then
        JAVA_HOME=/opt/java
    elif [ -f /usr/java/latest/jre/bin/java ]; then
        JAVA_HOME=/usr/java/latest ];
    else
        echo JAVA_HOME is not set properly.  Errors will likely follow ...    
    fi
fi

# Copy over in post-install script to avoid conflict with j2sdk
# In some installations we will have only the JRE.  Detect whether JAVA_HOME points to
# a JDK or JRE installation

if [ -d "$JAVA_HOME/jre" ] ; then
    # this is a JDK installation
    TARGET_JAVA_DIR="$JAVA_HOME/jre"
else
    # this is a JRE installation
    TARGET_JAVA_DIR="$JAVA_HOME"
fi

/bin/cp -af /opt/WiKID/conf/templates/java.security $TARGET_JAVA_DIR/lib/security/
/bin/cp -af /opt/WiKID/conf/templates/jce6/*.jar $TARGET_JAVA_DIR/lib/security/
/bin/cp -af /opt/WiKID/lib/xmlsec*.jar $TARGET_JAVA_DIR/lib/ext/
/bin/cp -af /opt/WiKID/lib/bcprov*.jar $TARGET_JAVA_DIR/lib/ext/


#/bin/cp -af /opt/WiKID/conf/templates/tomcat/server.xml /opt/WiKID/tomcat/conf/server.xml

tmpfile=`mktemp /tmp/wikidXXXXX`
if [ -z "$tmpfile" ];then
	# should never happen, but might
	tmpfile='/tmp_wikid_file'`date +%Y%m%d%H%M`
fi
echo "WIKID_CONFIGURED=1" > $tmpfile
if [ -f $SYSTEM_CONF ]; then
	grep -v WIKID_CONFIGURED $SYSTEM_CONF >> $tmpfile
fi
mv $tmpfile $SYSTEM_CONF

# TODO: enable this when we change the default to be non-root
# chown -R wikid /opt/WiKID 

